import es, playerlib, popuplib, gamethread

admin_list = ['STEAM_0:1:8592283','STEAM_0:1:9675545']

info = es.AddonInfo()
info['name'] = "Admin Teleport"
info['basename'] = "admin_teleport"
info['version'] = "1.1"
info['author'] = "Undead"
info['url'] = ""
info['description'] = "Advanced Teleport System"

es.ServerVar(info['basename'], info['version'], info['description']).makepublic()

dict_teleport = {}

def load():
  if not es.exists('saycommand', '!teleport'):
    es.regsaycmd('!teleport', 'admin_teleport/teleport_cmd')
  teleport_menu = popuplib.easymenu('teleport_menu', '_popup_choice', teleport_menu_select)
  teleport_menu.settitle("Select Option")
  teleport_menu.addoption('1', "Teleport To Player")
  teleport_menu.addoption('2', "Teleport Player To Me")
  teleport_menu.addoption('3', "Teleport To Saved Spot")
  teleport_menu.addoption('4', "Save Spot for Teleport")

def teleport_cmd():
  userid = es.getcmduserid()
  if es.getplayersteamid(userid) in admin_list:
    popuplib.send('teleport_menu', userid)

def teleport_menu_select(userid, choice, popupid):
  global dict_teleport
  user = int(userid)
  if choice == '1':
    target_list = popuplib.construct('target_list', 'players', '#alive', target_list_select)
    target_list.settitle("Select a Player: Tele to Player")
    popuplib.send('target_list', userid)
  elif choice == '2':
    target_list2 = popuplib.construct('target_list2', 'players', '#alive', target_list2_select)
    target_list2.settitle("Select a Player: Tele To Me")
    popuplib.send('target_list2', userid)
  elif choice == '3':
    a, b, c = dict_teleport[user]["loc"]
    es.server.queuecmd('es_setpos %s %s %s %s'%(int(userid), a, b, c))
    es.tell(userid, 'Teleport: Teleported to Saved Location!')
  elif choice == '4':
    dict_teleport[user]["loc"] = es.getplayerlocation(user)
    a, b, c = dict_teleport[user]["loc"]
    es.tell(userid, 'Teleport: Current Location Saved!')

def target_list_select(userid, choice, popupid):
  x,y,z = es.getplayerlocation(choice)
  es.server.queuecmd('es_setpos %s %s %s %s'%(int(userid), x,y,z))
  playerlib.getPlayer(int(userid)).set('noblock','1')
  playerlib.getPlayer(int(choice)).set('noblock','1')
  es.tell(int(userid), 'You teleported to %s!'%es.getplayername(choice))
  gamethread.delayed(5, unblock_player, (userid, choice))
  popuplib.delete('target_list')

def target_list2_select(userid, choice, popupid):
  x,y,z = es.getplayerlocation(userid)
  es.server.queuecmd('es_setpos %s %s %s %s'%(int(choice), x,y,z))
  playerlib.getPlayer(int(userid)).set('noblock','1')
  playerlib.getPlayer(int(choice)).set('noblock','1')
  es.tell(int(userid), '%s was teleported to you!'%es.getplayername(choice))
  gamethread.delayed(5, unblock_player, (userid, choice))
  popuplib.delete('target_list2')

def unblock_player(userid, choice):
  playerlib.getPlayer(int(choice)).set('noblock','0')
  playerlib.getPlayer(int(userid)).set('noblock','0')

def player_activate(ev):
  if ev['es_steamid'] in admin_list:
    user = int(ev['userid'])
    if user not in dict_teleport:
      dict_teleport[user] = {}
      dict_teleport[user]["loc"] = 0

def player_disconnect(ev):
  user = int(ev['userid'])
  if user in dict_teleport:
    del dict_teleport[user]

def unload():
  if es.exists('saycommand', '!teleport'):
    es.unregsaycmd('!teleport')